// FencryptorDoc.h : interface of the CFencryptorDoc class
//
/////////////////////////////////////////////////////////////////////////////

class CFencryptorDoc : public CDocument
{
protected: // create from serialization only
	CFencryptorDoc();
	DECLARE_DYNCREATE(CFencryptorDoc)
    BOOL NoError;
    CString SignatureMsg;

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFencryptorDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CFencryptorDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
    int KeyType;
	int KeySetType;
	int Algo;
	int Mode;

    int UnWrapFile(CArchive& ar);
	int WrapFile(CFile& ar);
    int BufferAppend(unsigned char* buffer, int count);
    int BufferDeduct(unsigned char* buffer, int count);
    int GetContextFromConfig( CRYPT_CONTEXT* cryptContext, 
	     CRYPT_CONTEXT* signContext);
    void SetDefault();

// Generated message map functions
protected:
	//{{AFX_MSG(CFencryptorDoc)
	afx_msg void OnToolConfiguration();
	afx_msg void OnViewSignature();
	afx_msg void OnFileEncryptAndSaveAs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
